//-----------------------------------------------------------------------------
//
// Title       : c_el_testbench
// Design      : Asynchronous_logic
// Author      : Rune A. Bjrnerud
// Company     : NTNU / Atmel Norway
//
//-----------------------------------------------------------------------------
//
// File        : c_el_testbench.v
// Generated   : Mon Mar  9 11:08:56 2009
// From        : interface description file
// By          : Itf2Vhdl ver. 1.21
//
//-----------------------------------------------------------------------------
//
// Description : 
//	Simple testbench for the C-element.
//-----------------------------------------------------------------------------
`timescale 1 ns / 1 ps

module c_el_testbench ();	
	parameter ClockPeriod = 20;

// **** Input registers ****	
reg clk, a_in, b_in; //inputs

// **** Output wires ****
wire s_out; //output 

// - instantiated module -
c_element C_EL (
	.a_in 	(a_in),
	.b_in	(b_in),
	.s_out	(s_out)
	);

initial clk = 1;
 always  
	 #(ClockPeriod / 2) clk = ! clk;
// - Testbench stimulus. To check signal transitions a clock is introduced. -	 
	 initial 
		 begin
			 clk = 0; //rst = 1;
			 a_in = 0; b_in = 0; //initial values	
				 
			
			# ClockPeriod a_in = 0; b_in = 0;
			# ClockPeriod a_in = 0; b_in = 1;
			# ClockPeriod a_in = 1; b_in = 0;
			# ClockPeriod a_in = 1; b_in = 1;
			
			# ClockPeriod a_in = 0; b_in = 0;
			# ClockPeriod a_in = 0; b_in = 1;
			# ClockPeriod a_in = 1; b_in = 0;
			# ClockPeriod a_in = 1; b_in = 1;	 
			
			# ClockPeriod a_in = 0; b_in = 1;
			# ClockPeriod a_in = 0; b_in = 0;
			# ClockPeriod a_in = 1; b_in = 1;
			# ClockPeriod a_in = 1; b_in = 0;
			
			# ClockPeriod a_in = 0; b_in = 0;
end

endmodule
