//---------------------------------------------------------------------
//
// Title       : c_element
// Design      : Asynchronous_logic
// Author      : Rune A. Bjrnerud
// Company     : NTNU / Atmel Norway
//
//---------------------------------------------------------------------
//
// File        : c_element.v
// Generated   : Mon Mar  9 10:06:03 2009
// From        : interface description file
// By          : Itf2Vhdl ver. 1.21
//
//---------------------------------------------------------------------
//
// Description : 
// This module describes an hazard free rtl implementation of a Mller 
//C-element. It is a very simple construction, with a feedback wire 
//from the output to AND gates connected to both inputs. This feedback 
//wire produce the stateholding quailty of the C-element. 
//The realization of this C-element is built on the sketches from appendix A
//in the main report.
//---------------------------------------------------------------------

`timescale 1 ns / 1 ps

//	****Instanciating module ****
module c_element (

//	****Input wires ****
	input wire	a_in,
	input wire  b_in,
	
//	**** Output wires and registers ****	
	output reg	s_out

);	 

//	**** Registers and wires ****	

reg w_1,w_2,w_3;

//	- Signal calculation -
	
	always @ (a_in , b_in)
		begin
			w_1 = a_in & b_in;
//Loop-back connection for stateholding
			w_2 = a_in & s_out;		 
			w_3	= b_in & s_out;
			s_out = w_1 | w_2 | w_3;
 		end
	
endmodule
