//-----------------------------------------------------------------------------
//
// Title       : wchb_network_test
// Design      : Asynchronous_logic
// Author      : pcdemon
// Company     : NTNU
//
//-----------------------------------------------------------------------------
//
// File        : wchb_network_test.v
// Generated   : Wed Mar 11 16:53:00 2009
// From        : interface description file
// By          : Itf2Vhdl ver. 1.21
//
//-----------------------------------------------------------------------------
//
// Description : 
//
//-----------------------------------------------------------------------------
`timescale 1 ns / 1 ps

//{{ Section below this comment is automatically maintained
//   and may be overwritten
//{module {wchb_network_test}}
module wchb_network_test ();

		parameter ClockPeriod = 20;
//}} End of automatically maintained section
reg clk, Ev_ci, Ev_di, rst, T_e_test;	//input
wire Ev_co, Ev_do, R_e_test;

//instantiated module
//T_e_test is input enable signal to the first module, while R_e is received
//from the last WCHB instance to the test bench when the handshake is complete.
wchb_handshake_network WCHB_netw_t(Ev_ci,Ev_di,T_e_test,rst,Ev_co,Ev_do,R_e_test);

initial clk = 1;
initial rst = 1;
 always  
	 #(ClockPeriod / 2) clk = ! clk;
	 
	 initial 
		 begin				
			 clk = 0;
			 rst = 0;
			 Ev_ci = 0; Ev_di = 0; T_e_test = 0; //initial values	
				 
			# ClockPeriod rst = 1;
			//The first sequence encodes the event bit "1"
			
		end		
					
					//# ClockPeriod Ev_ci = 0; Ev_di = 0; T_e_test = 1; 
					//# ClockPeriod Ev_ci = 1; Ev_di = 0; //T_e_test = 1;
					//# ClockPeriod Ev_ci = 0; Ev_di = 0; //T_e_test = 1;
					
					
		
					//# ClockPeriod Ev_ci = 1; Ev_di = 1; //T_e_test = 0;
					//Receiving buffer gets data, and R_e is set low to indicate this
					//# ClockPeriod Ev_ci = 0; Ev_di = 0; //T_e_test = 0;
					//sender initiates reset procedure, by setting data to "0". 
					//# ClockPeriod Ev_ci = 0; Ev_di = 0; //T_e_test = 1;
					//Start position, and receiving buffer is free to receive data.	   
		
		
		always @ (Ev_co | Ev_do | R_e_test | rst)
			begin
				if (!rst) 
				begin
					Ev_ci <= 0;
					Ev_di <= 0;
					T_e_test <= 0;
				end
				
					
			end
endmodule																			
